'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _commonTags = require('common-tags');

var _emphasize = require('emphasize');

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const deprecation = _chalk2.default.yellow('[ ⚠  Deprecation ⚠ ]');

/**
 * Log a deprecation warning about implicit dependencies
 * @param  {Object} application to log on
 */

exports.default = (application, file, registry) => {
	const names = (0, _lodash.values)(registry);

	const subject = _commonTags.oneLine`
		Found ${ names.length } implicit imports in ${ file.pattern.id }:${ file.name }.
		Implicit imports are deprecated and should be replaced with explicit
		ones.
		Implicit imports will be removed in version 1.0.
	`;

	const imports = Object.entries(registry).map(item => {
		var _item = _slicedToArray(item, 2);

		const unboundIdentifier = _item[0];
		const importName = _item[1];

		const name = importName === 'pattern' ? 'Pattern' : importName;
		return `import ${ unboundIdentifier } from '${ name }';`;
	}).join('\n');

	const warning = _commonTags.stripIndents`
		${ deprecation } ${ subject }

		${ _chalk2.default.bold(`Add the following import statements to ${ file.path }:`) }

		${ (0, _emphasize.highlight)('js', imports).value }
	`;

	application.log.warn(`${ warning }\n`);
};

module.change_code = 1; // eslint-disable-line

module.exports = exports['default'];