'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _babelTraverse = require('babel-traverse');

var _babelTraverse2 = _interopRequireDefault(_babelTraverse);

var _isAuxiliaryTopLevel = require('./is-auxiliary-top-level');

var _isAuxiliaryTopLevel2 = _interopRequireDefault(_isAuxiliaryTopLevel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isExcluded(excludes, path) {
	return excludes.includes(path.node) || excludes.includes(path);
}

/**
 * Check if a path has to reside in the render function
 * @param  {object}  path babel-ast path
 * @return {Boolean}
 */


/* import {
	isMemberExpression
} from 'babel-types'; */

function isRenderBound() {
	return true;
}

/**
 * Get auxiliary code to embed into component's render function
 * @param  {Object} ast
 * @param  {Array<Node>} ast nodes to exclude from search
 * @return {Array<Node>} ast nodes to emebd into render
 */

exports.default = (ast, exclude) => {
	const auxiliary = [];

	(0, _babelTraverse2.default)(ast, {
		exit: function exit(path) {
			if (!(0, _isAuxiliaryTopLevel2.default)(path)) {
				return;
			}

			if (isExcluded(exclude, path)) {
				return;
			}

			if (isRenderBound(path)) {
				auxiliary.push(path);
			}
		}
	});

	return auxiliary;
};

module.change_code = 1; // eslint-disable-line

module.exports = exports['default'];