'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _babelTraverse = require('babel-traverse');

var _babelTraverse2 = _interopRequireDefault(_babelTraverse);

var _isTopLevel = require('./is-top-level');

var _isTopLevel2 = _interopRequireDefault(_isTopLevel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isEntryJSX(path) {
	return 'openingElement' in path.node;
}

/**
 * Get JSX expressions residing in the outermost scope of a program
 * @param  {Object} ast to search in
 * @return {Array}      of JSX expressions in the outermost scope
 */

exports.default = ast => {
	const plain = [];

	(0, _babelTraverse2.default)(ast, {
		JSXElement: {
			exit: function exit(path) {
				if ((0, _isTopLevel2.default)(path) && isEntryJSX(path)) {
					plain.push(path);
				}
			}
		}
	});

	return plain;
};

module.change_code = 1; // eslint-disable-line

module.exports = exports['default'];