'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _bluebird = require('bluebird');

var _babylonAstDependencies = require('babylon-ast-dependencies');

var _babylonAstDependencies2 = _interopRequireDefault(_babylonAstDependencies);

var _resolve = require('resolve');

var _resolve2 = _interopRequireDefault(_resolve);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

const basedir = process.cwd();

function resolve(path) {
	let options = arguments.length <= 1 || arguments[1] === undefined ? { basedir: basedir } : arguments[1];

	return new Promise((resolver, reject) => {
		(0, _resolve2.default)(path, options, (error, result) => {
			if (error) {
				return reject(error);
			}
			resolver(result);
		});
	});
}

exports.default = (() => {
	var _ref = (0, _bluebird.coroutine)(function* (ast, file) {
		return yield Promise.all((0, _babylonAstDependencies2.default)(ast).map(function (dependency) {
			return dependency.source;
		}).map((() => {
			var _ref2 = (0, _bluebird.coroutine)(function* (dependencyName) {
				const name = dependencyName === 'pattern' ? 'Pattern' : dependencyName;

				const indexDependencies = file.dependencies.Pattern ? file.dependencies.Pattern : {};

				const resolveable = name in file.dependencies || name in indexDependencies;

				const meta = file.meta;


				if (resolveable) {
					return name;
				}

				const npmResolvable = yield resolve(name);

				if (npmResolvable) {
					const dependencies = [].concat(_toConsumableArray(meta.dependencies), [name.split('/')[0]]);
					meta.dependencies = [].concat(_toConsumableArray(new Set(dependencies)));
					return name;
				}

				const err = new Error([`Could not resolve dependency ${ name }`, `in ${ file.pattern.id }:${ file.name },`, 'it is not in pattern.json and could not be loaded from npm.', 'Available pattern dependencies:', Object.keys(file.dependencies).join(', ')].join(' '));

				err.fileName = file.path;
				err.file = file.path;
				throw err;
			});

			return function (_x4) {
				return _ref2.apply(this, arguments);
			};
		})()));
	});

	return function (_x2, _x3) {
		return _ref.apply(this, arguments);
	};
})();

module.change_code = 1; // eslint-disable-line

module.exports = exports['default'];