'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _babelTraverse = require('babel-traverse');

var _babelTraverse2 = _interopRequireDefault(_babelTraverse);

var _babelTypes = require('babel-types');

var _importTemplate = require('./import-template');

var _importTemplate2 = _interopRequireDefault(_importTemplate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * inject dependency imports into ast
 * @param  {Object} ast          babel ast
 * @param  {Object} dependencies importedName localName map
 * @return {Object}              babel ast with injected imports
 */
exports.default = (ast, dependencies) => {
	const imports = Object.entries(dependencies).map(item => {
		var _item = _slicedToArray(item, 2);

		const localName = _item[0];
		const importedName = _item[1];

		const name = importedName === 'pattern' ? 'Pattern' : importedName;

		return (0, _importTemplate2.default)({
			LOCAL: (0, _babelTypes.identifier)(localName),
			IMPORTED: (0, _babelTypes.stringLiteral)(name)
		});
	});

	(0, _babelTraverse2.default)(ast, {
		Program: {
			exit: function exit(path) {
				path.unshiftContainer('body', imports);
			}
		}
	});

	return ast;
};

module.change_code = 1; // eslint-disable-line

module.exports = exports['default'];